EaBIM一直以来积极响应国家“十二五”推进建筑业信息化的号召,对建筑领域的信息技术开展深入技术交流和探讨!致力于打造“BIM-建筑师-生态技术”三位一体综合资源交流共享平台,希望为BIM与可持续设计理念及技术的普及做出微小的贡献!!!

萧闫子 发表于 2014-1-15 14:01:38

Revit编程修改板的边界(含完整源代码)

我在ADN AEC英文博客中发表了一篇文章用于修改板的边界。Revit没有直接提供API来修改板的边界。发现了这个解决方案,先写了英文版的。这里就不翻译,直接贴过来。原帖地址:点击打开链接http://adndevblog.typepad.com/aec/2013/10/change-the-boundary-of-floorsslabs.html

Change the boundary of floors/slabsBy Joe Ye
Revit didn’t expose the API to edit floors/slabs boundary by now. Here introduce a trick to edit the boundary.For a Revit slab or floor, there are mapping model lines to representing the boundary of tha slab. If a floor boundary has 6 segments, there are 6 corresponding model lines for this floor. When we change those model line's position or shape, the slab or floor's shape will be updated accordingly.There probably are many model lines in a document. How can we find the model lines that representing the slab is the key point.Here is the solution: You need to create a tempt transaction. During this temp transaction, delete the target slab by Document.Delete() method. This method will return all the deleted elements' ids after the slab is deleted. So the slab's boundary model line can be find by iterating all the return id (get the element from those ids and compare the object type if they are ModelLine class). Finally abort this temp transaction.After get the boundary's boundary model lines, you can change the model line's shape by changing those ModelLine object ( use this methodLocationCurve lCurve = modelLine.Location as LocationCurve;
lCurve.Curve = newcurve.I just did a very quick test, this works.

Here is the complete command code.
For simplicity, it just moves the floor by creating new boundary lines by moving the old segment.Here suppose the segment lines are all straight lines.Transaction(
          Autodesk.Revit.Attributes.TransactionMode.Manual)]
      public class ChangeFloor : IExternalCommand
      {
          public Autodesk.Revit.UI.Result Execute(
            ExternalCommandData commandData,
            ref string message,
            ElementSet elements)
          {
            Document doc = commandData.Application.ActiveUIDocument.Document;
            Autodesk.Revit.UI.Selection.Selection sel =
            commandData.Application.ActiveUIDocument.Selection;

            Reference ref1 = sel.PickObject (Autodesk.Revit.UI.Selection.ObjectType.Element,
            "Please pick a floor to edit");
            Floor f = doc.GetElement(ref1) as Floor;

            Transaction transTemp = new Transaction(doc);
            transTemp.Start ("tempDelete");
            ICollection<ElementId> ids = doc.Delete(f);
            transTemp.RollBack ();

            List<ModelLine> mLines = new List<ModelLine>();
            foreach (ElementId id in ids)
            {
            Element ele = doc.GetElement (id);
            if (ele is ModelLine)
            {
                mLines.Add(ele as ModelLine);
            }
            }

            Transaction trans = new Transaction(doc);
            trans.Start("ChangeFloor");

            //
            foreach (ModelLine mline in mLines)
            {
            LocationCurve lCurve = mline.Location as LocationCurve;
            Line c = lCurve.Curve as Line;
            XYZ pt1 = c.GetEndPoint(0);
            XYZ pt2 = c.GetEndPoint(1);

            Transform transform = Transform.CreateTranslation(
                new XYZ(1, 1, 0)); //move the line.
            XYZ pt1New = transform.OfPoint (pt1);
            XYZ pt2New = transform.OfPoint (pt2);
            Line newLine = Line.CreateBound(pt1New, pt2New);
            lCurve.Curve = newLine;

            }
            trans.Commit ();
            return Result.Succeeded;
          }
      }

    }



转载请复制以下信息:
原文链接: http://blog.csdn.net/joexiongjin/article/details/12583387
作者:叶雄进 , Autodesk ADN

飞天舞 发表于 2014-2-14 10:16:18

顶!!!!!!!!!!!!!!!!!!!!!!!!!

chen_0003 发表于 2014-2-15 14:28:24

路过!!!
不发表意见……

筱雅 发表于 2014-2-15 14:33:07

路过!!!
不发表意见……

best 发表于 2014-2-15 14:41:54

路过!!!
帮顶……

MIMDxFzL 发表于 2014-2-18 12:03:22

路过!!!
不发表意见……

gba8297517 发表于 2014-2-20 14:06:55

顶!!!!!!!!!!

页: [1]
查看完整版本: Revit编程修改板的边界(含完整源代码)